﻿var tblAllDealers = '<table id="tblAllVehciles" class="table table-striped" >' +
    '<thead><tr><th></th></tr ></thead > <tbody></tbody></table>';

/*var domain = 'https://154.66.196.110/MobilityAPI/Vehicles.svc/'*/

var domain = 'http://localhost:4377/Vehicles.svc/';
var vehicleListing = null;

var selectedVehicleBody = null;
var selectedVehicleModel = null;
var selectedVehicleMake = null;

$(document).ready(function () {

    $("#txtVehicleYear")
        .datepicker({
            autoclose: true,
            format: " yyyy",
            viewMode: 2,
            minViewMode: 2,

            endDate: new Date(),
        }).on('changeDate', function (e) {

        });





    $("#ddlVehicleBody").change(function () {
        selectedVehicleBody = $(this).val();
        LoadVehicleMakesAndModel();
    });

    $("#ddlVehicleMake").change(function () {
        selectedVehicleMake = $(this).val();
        LoadVehicleModelAndBody();
    });

    $("#ddlVehicleModel").change(function () {
        selectedVehicleModel = $(this).val();
        LoadVehicleMakesAndBody();
    });

    LoadStartVehicleBodies();

})


function LoadStartVehicleBodies() {


    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleBodies",
        data: {
            make: $("#ddlVehicleMake option:selected").val(),
            model: $("#ddlVehicleModel option:selected").val(),
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {

            $("#ddlVehicleBody").html('');
            $("#ddlVehicleBody").append($('<option>').html('Please Select Body Type').attr('value', '').attr("selected", "selected"));


            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleBody").append($('<option>').html(data.aaData[i].BODY).attr('value', data.aaData[i].BODY))
                }
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {



        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
            LoadStartVehicleMakes();
        }


    });


}


function LoadStartVehicleMakes() {


    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleMakes",
        data: {
            body: $("#ddlVehicleBody option:selected").val(),
            model: $("#ddlVehicleModel option:selected").val(),
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {

            $("#ddlVehicleMake").html('');
            $("#ddlVehicleMake").append($('<option>').html('Please Select Make').attr('value', '').attr("selected", "selected"));


            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleMake").append($('<option>').html(data.aaData[i].MAKE).attr('value', data.aaData[i].MAKE))
                }
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {


        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
            LoadStartVehicleModels();
        }


    });


}


function LoadStartVehicleModels() {


    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehiclModels",
        data: {
            make: $("#ddlVehicleMake option:selected").val(),
            body: $("#ddlVehicleBody option:selected").val(),
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {
            $("#ddlVehicleModel").html('');
            $("#ddlVehicleModel").append($('<option>').html('Please Select Model').attr('value', '').attr("selected", "selected"));
            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleModel").append($('<option>').html(data.aaData[i].MODEL).attr('value', data.aaData[i].MODEL))
                }
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {


        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
        }


    });


}


function LoadVehicleMakesAndModel() {

    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleMakes",
        data: {
            body: selectedVehicleBody,
            model: selectedVehicleModel,
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {

            $("#ddlVehicleMake").html('');
            $("#ddlVehicleMake").append($('<option>').html('Please Select Make').attr('value', '').attr("selected", "selected"));


            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleMake").append($('<option>').html(data.aaData[i].MAKE).attr('value', data.aaData[i].MAKE))
                }
                $("#ddlVehicleMake").val(selectedVehicleMake);
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {


        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');

            $.ajax({
                xhrFields: {
                    withCredentials: false
                },
                url: domain + "GetVehiclModels",
                data: {
                    make: selectedVehicleMake,
                    body: selectedVehicleBody,
                    pricemin: $("#txtVehiclePriceMin").val(),
                    pricemax: $("#txtVehiclePriceMax").val(),
                    year: $("#txtVehicleYear").val(),
                    mileagemin: $("#txtVehicleMileageMin").val(),
                    mileagemax: $("#txtVehicleMileageMax").val(),
                },
                dataType: "json",

                success: function (data, e) {
                    $("#ddlVehicleModel").html('');
                    $("#ddlVehicleModel").append($('<option>').html('Please Select Model').attr('value', '').attr("selected", "selected"));
                    if (data.aaData.length > 0) {
                        for (var i = 0; i < data.aaData.length; i++) {


                            $("#ddlVehicleModel").append($('<option>').html(data.aaData[i].MODEL).attr('value', data.aaData[i].MODEL))
                        }
                        $("#ddlVehicleModel").val(selectedVehicleModel);
                    }
                    else {
                        alert(data);
                    }
                },
                error: function (data, e) {


                },
                complete: function () {
                    $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
                }


            });

        }


    });



}

function LoadVehicleMakesAndBody() {
    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleBodies",
        data: {
            make: selectedVehicleMake,
            model: selectedVehicleModel,
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {

            $("#ddlVehicleBody").html('');
            $("#ddlVehicleBody").append($('<option>').html('Please Select Body Type').attr('value', '').attr("selected", "selected"));


            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleBody").append($('<option>').html(data.aaData[i].BODY).attr('value', data.aaData[i].BODY))
                }
                $("#ddlVehicleBody").val(selectedVehicleBody);
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {


        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
            $.ajax({
                xhrFields: {
                    withCredentials: false
                },
                url: domain + "GetVehicleMakes",
                data: {
                    body: selectedVehicleBody,
                    model: selectedVehicleModel,
                    pricemin: $("#txtVehiclePriceMin").val(),
                    pricemax: $("#txtVehiclePriceMax").val(),
                    year: $("#txtVehicleYear").val(),
                    mileagemin: $("#txtVehicleMileageMin").val(),
                    mileagemax: $("#txtVehicleMileageMax").val(),
                },
                dataType: "json",

                success: function (data, e) {

                    $("#ddlVehicleMake").html('');
                    $("#ddlVehicleMake").append($('<option>').html('Please Select Make').attr('value', '').attr("selected", "selected"));


                    if (data.aaData.length > 0) {
                        for (var i = 0; i < data.aaData.length; i++) {


                            $("#ddlVehicleMake").append($('<option>').html(data.aaData[i].MAKE).attr('value', data.aaData[i].MAKE))
                        }
                        $("#ddlVehicleMake").val(selectedVehicleMake);
                    }
                    else {
                        alert(data);
                    }
                },
                error: function (data, e) {


                },
                complete: function () {
                    $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');

                }


            });
        }


    });


}


function LoadVehicleModelAndBody() {
    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleBodies",
        data: {
            make: selectedVehicleMake,
            model: selectedVehicleModel,
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {

            $("#ddlVehicleBody").html('');
            $("#ddlVehicleBody").append($('<option>').html('Please Select Body Type').attr('value', '').attr("selected", "selected"));


            if (data.aaData.length > 0) {
                for (var i = 0; i < data.aaData.length; i++) {


                    $("#ddlVehicleBody").append($('<option>').html(data.aaData[i].BODY).attr('value', data.aaData[i].BODY))
                }

                $("#ddlVehicleBody").val(selectedVehicleBody);
            }
            else {
                alert(data);
            }
        },
        error: function (data, e) {



        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');

            $.ajax({
                xhrFields: {
                    withCredentials: false
                },
                url: domain + "GetVehiclModels",
                data: {
                    make: selectedVehicleMake,
                    body: selectedVehicleBody,
                    pricemin: $("#txtVehiclePriceMin").val(),
                    pricemax: $("#txtVehiclePriceMax").val(),
                    year: $("#txtVehicleYear").val(),
                    mileagemin: $("#txtVehicleMileageMin").val(),
                    mileagemax: $("#txtVehicleMileageMax").val(),
                },
                dataType: "json",

                success: function (data, e) {
                    $("#ddlVehicleModel").html('');
                    $("#ddlVehicleModel").append($('<option>').html('Please Select Model').attr('value', '').attr("selected", "selected"));
                    if (data.aaData.length > 0) {
                        for (var i = 0; i < data.aaData.length; i++) {


                            $("#ddlVehicleModel").append($('<option>').html(data.aaData[i].MODEL).attr('value', data.aaData[i].MODEL))
                        }
                        $("#ddlVehicleModel").val(selectedVehicleModel);
                    }
                    else {
                        alert(data);
                    }
                },
                error: function (data, e) {


                },
                complete: function () {
                    $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
                }


            });

        }


    });

}


function SearchVehicle() {


    $.ajax({
        xhrFields: {
            withCredentials: false
        },
        url: domain + "GetVehicleDetails",
        data: {
            make: selectedVehicleMake,
            body: selectedVehicleBody,
            model: selectedVehicleModel,
            pricemin: $("#txtVehiclePriceMin").val(),
            pricemax: $("#txtVehiclePriceMax").val(),
            year: $("#txtVehicleYear").val(),
            mileagemin: $("#txtVehicleMileageMin").val(),
            mileagemax: $("#txtVehicleMileageMax").val(),
        },
        dataType: "json",

        success: function (data, e) {
            ShowVehicles(data.aaData);
        },
        error: function (data, e) {


        },
        complete: function () {
            $("#divLoadingTable").hide(); $('#dvDim').fadeOut('slow');
        }


    });




}
var vehicleImagesObj

function ShowVehicles(vehicleList) {

    $('#divAllVehicle').html(tblAllDealers)
    $("#tblAllVehciles").DataTable({
        aaData: vehicleList,
        columns: [
            { data: 'DATEUPLOADED' }

        ],
        initComplete: function (settings, json) {
            /*$('.sorting_1').parent().hide();*/
        },
        pageLength: 10,
        paging: true,
        bSort: false,
        autoWidth: false,
        bFilter: false,
        rowCallback: function (row, data) {
            var vehicleImages = "";
            var selectedimage = "", selectedimageType = "";
            for (var i = 0; i < data.vehicleImageList.length; i++) {

                if (selectedimage == "") {
                selectedimage = data.vehicleImageList[i].VEHICLEIMAGE;
                    selectedimageType = data.vehicleImageList[i].IMAGETYPE;


                }
                
                vehicleImages = vehicleImages + "<img onclick='ShowImageDetail($(this)," + data.VEHICLEID+")' style='width:150px;height:150px;float:left' src='data:image/" + data.vehicleImageList[i].IMAGETYPE + "; base64," + data.vehicleImageList[i].VEHICLEIMAGE + "'>";
                  



            }


            var vehicleDetails = $('<div>').addClass('col-lg-12')
                .append($('<div>').addClass('col-lg-6')
                    .append($('<div>').addClass('col-lg-12')
                        .append($('<img>').attr('id', 'Vehicle' + data.VEHICLEID).attr('src', 'data:image/' + selectedimageType + '; base64,' + selectedimage).addClass('col-lg-12'))
                    .append($('<div>').addClass('col-lg-12').html(vehicleImages))
                      )
                )

                .append($('<div>').addClass('col-lg-6')
                    .append($('<label>').addClass("control-label col-lg-12").html(data.MAKE + ' ' + data.MODEL + ' ' + data.TRANSMISSION))
                    .append($('<label>').addClass("control-label col-lg-12").html('Transmission: ' + data.TRANSMISSION))
                    .append($('<label>').addClass("control-label col-lg-12").html('Mileage: ' + data.MILEAGE + ' km'))
                    .append($('<label>').addClass("control-label col-lg-12").html('Price: R' + data.PRICE))
                    .append($('<label>').addClass("control-label col-lg-12").html('Condition: ' + data.CONDITION))
                    .append($('<label>').addClass("control-label col-lg-12").html('Fuel Type: ' + data.FUELTYPE))
                    .append($('<label>').addClass("control-label col-lg-12").html('Description: ' + data.DESCRIPTION))
                    .append($('<label>').addClass("control-label col-lg-12").html('Comments: ' + data.COMMENTS))
                )
            $('td:eq(0)', row).html(vehicleDetails)



        },
    });


}


function ShowImageDetail(ImageObj, VehicleID) {


    $("#Vehicle" + VehicleID).attr('src', $(ImageObj).attr('src'));


}